#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void chyba(char *s) {
	printf("%s\n", s);
	exit(1);
}

char *strleft(char *src, int x) {
	char *dest = malloc(x+1);
	int i;
	for (i=0; i < x && src[i]; i++) dest[i] = src[i];
	dest[x] = 0;
	return dest;
}

char *strright(char *src, int x) {
	char *dest = malloc(strlen(src) - x);
	int i;
	for (i=0; src[i]; i++) dest[i] = src[i+x];
	dest[i] = 0;
	return dest;
}

long cislo(char *x) {
	int i;
	long y=0;
	for (i=0; x[i]; i++) {
		if (x[i] <= '9' || x[i] >= '0')
			y = 10*y + (x[i] - '0');
		else chyba("Neznamy vstupni znak");
	}
	return y;
}

long spocti(char *x);

long zavorky(char *x) {
	char *y = malloc(strlen(x)-1);
	strncpy(y, x+1, strlen(x)-2);
	y[strlen(x)-2] = 0;
	return spocti(y);
}

long vyhodnot(char *x, char op, char *y) {
	if (!x || !y) chyba("Spatny pocet znamenek");
	switch (op) {
		case '+': return spocti(x) + spocti(y);
		case '-': return spocti(x) - spocti(y);
		case '*': return spocti(x) * spocti(y);
		case '/': return spocti(x) / spocti(y);
		default: return 0;
	}
}

long spocti(char *x) {
	int zavorek = 0;
	int op1 = -1;
	int op2 = -1;
	int op = -1;

	int i;
	for(i=0; x[i]; i++) {
		switch (x[i]) {
			case '(': zavorek++; break;
			case ')': if (zavorek) zavorek--; else chyba("Spatny pocet zavorek"); break;
			case '+':
			case '-': if (!zavorek) op1 = i; break;
			case '*':
			case '/': if (!zavorek) op2 = i; break;
		}
	}

	if (zavorek) chyba("Spatny pocet zavorek");
	if (op1 >= 0) op = op1; else if (op2 >= 0) op = op2;
	if (op >= 0) return vyhodnot(strleft(x, op), x[op], strright(x, op+1));
	else if (x[0] == '(') return zavorky(x);
	else return cislo(x);
}

long main(int argc, char *argv[]) {
	char vyraz[255];
	long vysledek;
	int i;
	vyraz[0] = 0;
	for(i=1; i < argc; i++) strcat(vyraz, argv[i]);
	if (!*vyraz) chyba("Syntaxe: VYRAZ.EXE vyraz\n  vyraz: matematicky vyraz ( + - * / ( ) cisla )");
	vysledek = spocti(vyraz);
	printf("%s = %d\n", vyraz, vysledek);
	return vysledek;
}
